#include "Change File Date Time.h"

HICON g_hIcon;
HWND g_hWndDialog;
HINSTANCE g_hInstance;

int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	g_hInstance = hInstance;
	InitCommonControls();
	g_hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1) );
 	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);	
	DestroyIcon(g_hIcon);
	return 0;
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	
	switch (uMsg)
	{
		case WM_COMMAND:
		if ( HIWORD(wParam) == EN_CHANGE && LOWORD(wParam) == IDC_EB_PATH )
				GetDateTime();
		if (HIWORD(wParam) == BN_CLICKED)// On button click 
		{
			switch(LOWORD(wParam))
			{
			case IDC_CB_MILISEC:
			if (IsDlgButtonChecked(g_hWndDialog,IDC_CB_MILISEC) == BST_CHECKED)
				EnableWindow(GetDlgItem(hwndDlg,IDC_EB_MILISEC),TRUE);
			else
				EnableWindow(GetDlgItem(hwndDlg,IDC_EB_MILISEC),FALSE);
				break;
			case IDC_OB_CREATED:
			case IDC_OB_MODIFIED:
			case IDC_OB_ACCESSED:
				GetDateTime();
				break;

			case IDC_BTN_GETDATE:
				GetDateTime();
				break;
			case IDC_BTN_FILE:
				GetFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_PATH));
				GetDateTime();
				break;
			case IDC_BTN_FOLDER:
				GetFolderPath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_PATH));
				GetDateTime();
				break;
			case IDC_BTN_APPLY:
				if (SetDateTime() == FALSE)
					MessageBox(hwndDlg,"Unable to apply change.","Error",MB_OK |MB_ICONHAND);
				GetDateTime();
				break;
			case IDC_BTN_ABOUT:
				DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_ABOUT),hwndDlg,(DLGPROC)AboutDlgProc);
				break;
			}
		}
		break;
	case WM_INITDIALOG:
		 g_hWndDialog = hwndDlg;
		 SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		 CheckDlgButton(hwndDlg,IDC_OB_CREATED,BST_CHECKED);
		 EnableWindow(GetDlgItem(hwndDlg,IDC_EB_MILISEC),FALSE);
		 EnableControls(FALSE);
		 return TRUE;
	case WM_CLOSE:
			EndDialog(hwndDlg,0);
			break;
	}

	return FALSE;
}
INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam == IDC_CMD_OK)
			EndDialog(hwndDlg,0);
			break;
	case WM_INITDIALOG:
		SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		return true;
	case WM_CLOSE:
		EndDialog(hwndDlg,0);
		break;
	}
	return FALSE;
}

BOOL SetDateTime(void)
{
	char szPath[MAX_PATH];

	if ( GetDlgItemText(g_hWndDialog,IDC_EB_PATH,szPath,sizeof(szPath)) == NULL)
		return FALSE;
	if ( PathFileExists(szPath) == FALSE )
		return FALSE;

	HANDLE hFile = OpenFileForWrite(szPath);
	if ( hFile ==   INVALID_HANDLE_VALUE )
		return FALSE;

	FILETIME ftDateTime;
	LPFILETIME lpftCreation = NULL;
	LPFILETIME lpftAccess	= NULL;
	LPFILETIME lpftModified = NULL;
	FILETIME ftSys;
	SYSTEMTIME stDate;
	SYSTEMTIME stTime;

	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_CREATED) == BST_CHECKED)
			lpftCreation = &ftDateTime;
	
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_ACCESSED) == BST_CHECKED)
			lpftAccess = &ftDateTime;
	
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_MODIFIED) == BST_CHECKED)
			lpftModified = &ftDateTime;	

	DateTime_GetSystemtime(GetDlgItem(g_hWndDialog,IDC_DT_DATE),&stDate);
	DateTime_GetSystemtime(GetDlgItem(g_hWndDialog,IDC_DT_TIME),&stTime);
	stDate.wHour	= stTime.wHour;
	stDate.wMinute  = stTime.wMinute;
	stDate.wSecond  = stTime.wSecond;

	char szMiliSec[8];
	if (IsDlgButtonChecked(g_hWndDialog,IDC_CB_MILISEC) == BST_CHECKED){
			if ( GetDlgItemText(g_hWndDialog,IDC_EB_MILISEC,szMiliSec,sizeof(szMiliSec)) > 0)
					stDate.wMilliseconds = (WORD) atoi(szMiliSec);
	}

	SystemTimeToFileTime(&stDate,&ftSys);
	LocalFileTimeToFileTime(&ftSys,&ftDateTime);

	if (SetFileTime(hFile,lpftCreation,lpftAccess,lpftModified) == FALSE)
	{
	CloseHandle(hFile);
	return FALSE;
	}

	CloseHandle(hFile);
	return TRUE;
}
void GetDateTime(void)
{
	char szPath[MAX_PATH];

	if ( GetDlgItemText(g_hWndDialog,IDC_EB_PATH,szPath,sizeof(szPath)) == NULL){
		EnableControls(FALSE);
		return ;
	}
		if ( PathFileExists(szPath) == FALSE ){
		EnableControls(FALSE);
		return ;
	}
	EnableControls(TRUE);
	
	HANDLE hFile = OpenFileForRead(szPath);

	if ( hFile ==   INVALID_HANDLE_VALUE )
	{
		EnableControls(FALSE);
		return ;
	}
	EnableControls(TRUE);

	FILETIME ftCreation;
	FILETIME ftAccess;
	FILETIME ftModified;
	
	if ( GetFileTime(hFile,&ftCreation,&ftAccess,&ftModified) == NULL)
	{
	EnableControls(FALSE);
	CloseHandle(hFile);
	return;
	}
	EnableControls(TRUE);
	CloseHandle(hFile);

	SYSTEMTIME stDateTime;
	LPFILETIME lpFileTime;
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_CREATED) == BST_CHECKED)
			lpFileTime = &ftCreation ;
	
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_ACCESSED) == BST_CHECKED)
			lpFileTime = &ftAccess ;
	
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_MODIFIED) == BST_CHECKED)
			lpFileTime = &ftModified ;	

	FILETIME ftLocal;
	FileTimeToLocalFileTime(lpFileTime,&ftLocal);
	FileTimeToSystemTime(&ftLocal,&stDateTime);
	
	char szMiliSec[8];
	wsprintf(szMiliSec,"%hu",stDateTime.wMilliseconds);
	SetDlgItemText(g_hWndDialog,IDC_EB_MILISEC,szMiliSec);

	DateTime_SetSystemtime(GetDlgItem(g_hWndDialog,IDC_DT_DATE),GDT_VALID,&stDateTime);
	DateTime_SetSystemtime(GetDlgItem(g_hWndDialog,IDC_DT_TIME),GDT_VALID,&stDateTime);

}
HANDLE OpenFileForRead(LPSTR szFileName)
{
	return CreateFile(szFileName,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,
		NULL);
}
HANDLE OpenFileForWrite(LPSTR szFileName)
{
 return CreateFile(szFileName,
		FILE_WRITE_ATTRIBUTES,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS,
		NULL);
}
void EnableControls(BOOL bEnable)
{

EnableWindow(GetDlgItem(g_hWndDialog,IDC_OB_CREATED),bEnable);
EnableWindow(GetDlgItem(g_hWndDialog,IDC_OB_MODIFIED),bEnable);
EnableWindow(GetDlgItem(g_hWndDialog,IDC_OB_ACCESSED),bEnable);

EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_GETDATE),bEnable);
EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_APPLY),bEnable);

EnableWindow(GetDlgItem(g_hWndDialog,IDC_DT_DATE),bEnable);
EnableWindow(GetDlgItem(g_hWndDialog,IDC_DT_TIME),bEnable);
EnableWindow(GetDlgItem(g_hWndDialog,IDC_CB_MILISEC),bEnable);

if (IsDlgButtonChecked(g_hWndDialog,IDC_CB_MILISEC) == BST_CHECKED)
	EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_MILISEC),bEnable);

}
/*
This software created by Muhammad Arshad Latti
From Sargodha ( Pakistan) 
e-mail   :: arshadlatti@gmail.com 
web_site :: http://www.geocities.com/arshadlati
*/